/* 
 * Copyright (C) 2003 Star Chamber Inc.
 *
 * Sussen - sussen-cert-druid.c
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Author: Loren Bandiera <lorenb@starchamber.ca>
 */

#include "sussen.h"
#include "sussen-util.h"
#include "sussen-cert-druid.h"

/*
 * FIXME: Seems to be a bug in libglade, the druid doesn't display the
 *        start and end pages.  Had to 'build source' from glade2 to make 
 *		  it work.  Odd that it works when building from source but not loading
 *		  from xml.
 */

GtkWidget *druid;
gint user_response;

GtkWidget* create_sussen_cert_druid_dialog (void) {

	GtkWidget *sussen_cert_druid_dialog;
	GtkWidget *dialog_vbox1;
	GtkWidget *sussen_cert_druid;
	GtkWidget *start_page;
	GtkWidget *cert_page;
	GtkWidget *druid_vbox6;
	GtkWidget *vbox6;
	GtkWidget *frame3;
	GtkWidget *scrolledwindow3;
	GtkWidget *cert_textview;
	GtkWidget *label3;
	GtkWidget *vbox7;
	GtkWidget *cert_druid_accept_radio;
	GSList *cert_druid_accept_radio_group = NULL;
	GtkWidget *cert_druid_verify_radio;
	GtkWidget *cert_druid_reject_radio;
	GtkWidget *finish_page;
	GtkWidget *dialog_action_area1;

	sussen_cert_druid_dialog = gtk_dialog_new ();
	gtk_window_set_title (GTK_WINDOW (sussen_cert_druid_dialog), _("Certificate Druid"));

	dialog_vbox1 = GTK_DIALOG (sussen_cert_druid_dialog)->vbox;
	gtk_widget_show (dialog_vbox1);

	sussen_cert_druid = gnome_druid_new ();
	gtk_widget_show (sussen_cert_druid);
	gtk_box_pack_start (GTK_BOX (dialog_vbox1), sussen_cert_druid, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (sussen_cert_druid), 4);

	start_page = gnome_druid_page_edge_new (GNOME_EDGE_START);
	gtk_widget_show (start_page);
	gnome_druid_append_page (GNOME_DRUID (sussen_cert_druid),
							GNOME_DRUID_PAGE (start_page));
	gnome_druid_page_edge_set_title (GNOME_DRUID_PAGE_EDGE (start_page),
							_("Certificate Druid"));
	gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (start_page),
							_("The server you are attempting to connect to has credentials you have never seen before."));

	cert_page = gnome_druid_page_standard_new ();
	gtk_widget_show_all (cert_page);
	gnome_druid_append_page (GNOME_DRUID (sussen_cert_druid),
							GNOME_DRUID_PAGE (cert_page));

	druid_vbox6 = GNOME_DRUID_PAGE_STANDARD (cert_page)->vbox;
	gtk_widget_show (druid_vbox6);
	gtk_container_set_border_width (GTK_CONTAINER (druid_vbox6), 16);

	vbox6 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox6);
	gtk_box_pack_start (GTK_BOX (druid_vbox6), vbox6, TRUE, TRUE, 0);

	frame3 = gtk_frame_new (NULL);
	gtk_widget_show (frame3);
	gtk_box_pack_start (GTK_BOX (vbox6), frame3, TRUE, TRUE, 0);

	scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow3);
	gtk_container_add (GTK_CONTAINER (frame3), scrolledwindow3);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	cert_textview = gtk_text_view_new ();
	gtk_widget_show (cert_textview);
	gtk_container_add (GTK_CONTAINER (scrolledwindow3), cert_textview);
	gtk_text_view_set_editable (GTK_TEXT_VIEW (cert_textview), FALSE);

	label3 = gtk_label_new (_("Certificate"));
	gtk_widget_show (label3);
	gtk_frame_set_label_widget (GTK_FRAME (frame3), label3);
	gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_LEFT);

	vbox7 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox7);
	gtk_box_pack_start (GTK_BOX (vbox6), vbox7, FALSE, FALSE, 0);

	cert_druid_accept_radio = gtk_radio_button_new_with_mnemonic (NULL, _("Accept certificate"));
	gtk_widget_show (cert_druid_accept_radio);
	gtk_box_pack_start (GTK_BOX (vbox7), cert_druid_accept_radio, FALSE, FALSE, 0);
	gtk_radio_button_set_group (GTK_RADIO_BUTTON (cert_druid_accept_radio), cert_druid_accept_radio_group);
	cert_druid_accept_radio_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (cert_druid_accept_radio));

	cert_druid_verify_radio = gtk_radio_button_new_with_mnemonic (NULL, _("Accept certificate only if server identity can be verified"));
	gtk_widget_show (cert_druid_verify_radio);
	gtk_box_pack_start (GTK_BOX (vbox7), cert_druid_verify_radio, FALSE, FALSE, 0);
	gtk_radio_button_set_group (GTK_RADIO_BUTTON (cert_druid_verify_radio), cert_druid_accept_radio_group);
	cert_druid_accept_radio_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (cert_druid_verify_radio));

	cert_druid_reject_radio = gtk_radio_button_new_with_mnemonic (NULL, _("Reject certificate"));
	gtk_widget_show (cert_druid_reject_radio);
	gtk_box_pack_start (GTK_BOX (vbox7), cert_druid_reject_radio, FALSE, FALSE, 0);
	gtk_radio_button_set_group (GTK_RADIO_BUTTON (cert_druid_reject_radio), cert_druid_accept_radio_group);
	cert_druid_accept_radio_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (cert_druid_reject_radio));
	
	finish_page = gnome_druid_page_edge_new (GNOME_EDGE_FINISH);
	gtk_widget_show (finish_page);
	gnome_druid_append_page (GNOME_DRUID (sussen_cert_druid),
							GNOME_DRUID_PAGE (finish_page));
	gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (finish_page),
									_(" "));

	dialog_action_area1 = GTK_DIALOG (sussen_cert_druid_dialog)->action_area;
	gtk_widget_show (dialog_action_area1);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

	/* Store pointers to all widgets, for use by lookup_widget(). */
	GLADE_HOOKUP_OBJECT_NO_REF (sussen_cert_druid_dialog, sussen_cert_druid_dialog, "sussen_cert_druid_dialog");
	GLADE_HOOKUP_OBJECT_NO_REF (sussen_cert_druid_dialog, dialog_vbox1, "dialog_vbox1");
	GLADE_HOOKUP_OBJECT (sussen_cert_druid_dialog, sussen_cert_druid, "sussen_cert_druid");
	GLADE_HOOKUP_OBJECT (sussen_cert_druid_dialog, start_page, "start_page");
	GLADE_HOOKUP_OBJECT (sussen_cert_druid_dialog, cert_page, "cert_page");
	GLADE_HOOKUP_OBJECT (sussen_cert_druid_dialog, druid_vbox6, "druid_vbox6");
	GLADE_HOOKUP_OBJECT (sussen_cert_druid_dialog, vbox6, "vbox6");
	GLADE_HOOKUP_OBJECT (sussen_cert_druid_dialog, frame3, "frame3");
	GLADE_HOOKUP_OBJECT (sussen_cert_druid_dialog, scrolledwindow3, "scrolledwindow3");
	GLADE_HOOKUP_OBJECT (sussen_cert_druid_dialog, cert_textview, "cert_textview");
	GLADE_HOOKUP_OBJECT (sussen_cert_druid_dialog, label3, "label3");
	GLADE_HOOKUP_OBJECT (sussen_cert_druid_dialog, vbox7, "vbox7");
	GLADE_HOOKUP_OBJECT (sussen_cert_druid_dialog, cert_druid_accept_radio, "cert_druid_accept_radio");
	GLADE_HOOKUP_OBJECT (sussen_cert_druid_dialog, cert_druid_verify_radio, "cert_druid_verify_radio");
	GLADE_HOOKUP_OBJECT (sussen_cert_druid_dialog, cert_druid_reject_radio, "cert_druid_reject_radio");
	GLADE_HOOKUP_OBJECT (sussen_cert_druid_dialog, finish_page, "finish_page");
	GLADE_HOOKUP_OBJECT_NO_REF (sussen_cert_druid_dialog, dialog_action_area1, "dialog_action_area1");

	return sussen_cert_druid_dialog;
}

void finish_page_done (GnomeDruidPage *druidpage, GtkWidget *widget, gpointer user_data) {

	gtk_widget_destroy (druid);
	gtk_main_quit ();
}

void cert_page_next (GnomeDruidPage *druidpage, GtkWidget *widget, gpointer user_data) {
	
	GSList *list;
	GtkWidget *cert_druid;
	GtkWidget *button;
	GtkWidget *finish_page;
	
	cert_druid = lookup_widget (druid,"sussen_cert_druid");
	finish_page = lookup_widget (druid,"finish_page");
	button = lookup_widget (druid, "cert_druid_accept_radio");
	list = gtk_radio_button_get_group (GTK_RADIO_BUTTON(button));
	
	if (list) {
		while (list) {
			
			GtkWidget *button = list->data;
			
			
			if(GTK_TOGGLE_BUTTON(button)->active) {
				
				user_response = (gint)g_object_get_data(G_OBJECT(button), "response");
				
				switch (user_response) {
				
					case CERT_DRUID_ACCEPT:
						gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (finish_page),
														_("You have chosen to accept the server certificate, it will now be saved for future use"));
						break;

					case CERT_DRUID_VERIFY:
						gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (finish_page),
														_("About to verify server certificate, click Apply to finish"));
						break;

					
					case CERT_DRUID_REJECT:
						gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (finish_page),
														_("You have rejected the server certificate, you will not be able to login to the server.  Click Apply to continue"));
						break;
											
					default:
						break;
				}
			}
			list = list->next;
		}
	}
	
	gnome_druid_set_page (GNOME_DRUID(cert_druid),GNOME_DRUID_PAGE (finish_page));
}

/*
int show_cert_druid (SSL *ssl) {
	
	char *cert_plaintext;
	X509 *cert = SSL_get_peer_certificate (ssl);
	BIO *b;
	BUF_MEM *bptr;
	
	b = BIO_new(BIO_s_mem());
	if(X509_print(b, cert) > 0) {
		BIO_get_mem_ptr(b, &bptr);
		cert_plaintext = malloc(1 + bptr->length);
  		memcpy(cert_plaintext, bptr->data, bptr->length);
	 }
	else
	{
		cert_plaintext = emalloc(1024);
		sprintf(cert_plaintext, "This certificate has never been seen before and can't be shown\n");
 	}
 
	BIO_free(b);
	
	GtkWidget *w;
	GtkTextBuffer *buf;

	druid = create_sussen_cert_druid_dialog ();
	gtk_widget_show (druid);
*/
	/* configure radio buttons 
	 * 	1 = accept certificate
	 *  2 = accept if cert can be verified
	 *	3 = reject certificate
	 */
/*	
	w = lookup_widget (druid, "cert_druid_accept_radio");
	g_object_set_data(G_OBJECT(w), "response", (void*)CERT_DRUID_ACCEPT);
	
	w = lookup_widget (druid, "cert_druid_verify_radio");
	g_object_set_data(G_OBJECT(w), "response", (void*)CERT_DRUID_VERIFY);
	
	w = lookup_widget (druid, "cert_druid_reject_radio");
	g_object_set_data(G_OBJECT(w), "response", (void*)CERT_DRUID_REJECT);

	
	w = lookup_widget (druid, "sussen_cert_druid");
	g_signal_connect_swapped (GTK_OBJECT (w),
							  "cancel",
							  G_CALLBACK (gtk_widget_destroy),
							  (gpointer) druid);	

	
	w = lookup_widget (druid, "cert_page");
	g_signal_connect (GTK_OBJECT (w),
					  "next",
					  G_CALLBACK (cert_page_next),
					  NULL);	

	w = lookup_widget (druid, "finish_page");
	g_signal_connect (GTK_OBJECT (w),
					  "finish",
					  G_CALLBACK (finish_page_done),
					  NULL);

	w = lookup_widget (druid,"cert_textview");
	buf = gtk_text_view_get_buffer (GTK_TEXT_VIEW (w));
	gtk_text_buffer_set_text (buf, cert_plaintext, -1);
	gtk_text_view_set_buffer (GTK_TEXT_VIEW(w),buf);
	
	gtk_main ();
	
	return user_response;
}
*/
