/* 
 * Copyright (C) 2003 Star Chamber Inc.
 *
 * Sussen - sussen-getting-started-druid.c
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Author: Loren Bandiera <lorenb@starchamber.ca>
 */
 
 #include "sussen.h"
 #include "sussen-fileio.h"
 #include "sussen-util.h"
 #include "sussen-getting-started-druid.h"
 #include <libgnomedb/libgnomedb.h>
 #include <libgnomedb/gnome-db-data-source-selector.h>
 
 /*
 * FIXME: Seems to be a bug in libglade, the druid doesn't display the
 *        start and end pages.  Had to 'build source' from glade2 to make 
 *		  it work.  Odd that it works when building from source but not loading
 *		  from xml.
 */

GtkWidget *druid;
gboolean create_new_connection = FALSE;

gchar *existing_dsn = NULL;
gchar *existing_dsn_user = NULL;
gchar *existing_dsn_pass = NULL;

GtkWidget* create_sussen_getting_started_druid_dialog (void) {

	GtkWidget *getting_started_dialog;
	GtkWidget *dialog_vbox1;
	GtkWidget *getting_started_druid;
	GtkWidget *start_page;
	GtkWidget *page1;
	GtkWidget *druid_vbox1;
	GtkWidget *fixed1;
	GtkWidget *label1;
	GtkWidget *nessusd_entry;
	GtkObject *port_spin_button_adj;
	GtkWidget *port_spin_button;
	GtkWidget *label2;
	GtkWidget *label3;
	GtkWidget *nessusd_username_entry;
	GtkWidget *page2;
	GtkWidget *druid_vbox2;
	GtkWidget *vbox1;
	GtkWidget *label4;
	GtkWidget *hbox1;
	GtkWidget *db_radio_button;
	GSList *db_radio_button_group = NULL;
	GtkWidget *dbdatasourceselector1;
	GtkWidget *new_dsn_radio;
	GtkWidget *end_page;
	GtkWidget *dialog_action_area1;

	getting_started_dialog = gtk_dialog_new ();
	gtk_window_set_title (GTK_WINDOW (getting_started_dialog), _("Getting Started"));
	gtk_dialog_set_has_separator (GTK_DIALOG (getting_started_dialog), FALSE);

	dialog_vbox1 = GTK_DIALOG (getting_started_dialog)->vbox;
	gtk_widget_show (dialog_vbox1);

	getting_started_druid = gnome_druid_new ();
	gtk_widget_show (getting_started_druid);
	gtk_box_pack_start (GTK_BOX (dialog_vbox1), getting_started_druid, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (getting_started_druid), 4);

	start_page = gnome_druid_page_edge_new (GNOME_EDGE_START);
	gtk_widget_show (start_page);
	gnome_druid_append_page (GNOME_DRUID (getting_started_druid),
							GNOME_DRUID_PAGE (start_page));
	gnome_druid_page_edge_set_title (GNOME_DRUID_PAGE_EDGE (start_page),
									_("Getting Started"));
	gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (start_page),
									_("This is the first time you have run Sussen.  The program will need to collect some information from you.  Click 'Forward' to continue."));

	page1 = gnome_druid_page_standard_new ();
	gtk_widget_show_all (page1);
	gnome_druid_append_page (GNOME_DRUID (getting_started_druid),
							GNOME_DRUID_PAGE (page1));
	gnome_druid_page_standard_set_title (GNOME_DRUID_PAGE_STANDARD (page1), _("Nessus Server Information"));

	druid_vbox1 = GNOME_DRUID_PAGE_STANDARD (page1)->vbox;
	gtk_widget_show (druid_vbox1);
	gtk_container_set_border_width (GTK_CONTAINER (druid_vbox1), 16);

	fixed1 = gtk_fixed_new ();
	gtk_widget_show (fixed1);
	gtk_box_pack_start (GTK_BOX (druid_vbox1), fixed1, TRUE, TRUE, 0);

	label1 = gtk_label_new (_("Server Hostname:"));
	gtk_widget_show (label1);
	gtk_fixed_put (GTK_FIXED (fixed1), label1, 8, 24);
	gtk_widget_set_size_request (label1, 143, 22);
	gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);

	nessusd_entry = gtk_entry_new ();
	gtk_widget_show (nessusd_entry);
	gtk_fixed_put (GTK_FIXED (fixed1), nessusd_entry, 160, 24);
	gtk_widget_set_size_request (nessusd_entry, 314, 25);

	port_spin_button_adj = gtk_adjustment_new (1241, 0, 65000, 1, 10, 10);
	port_spin_button = gtk_spin_button_new (GTK_ADJUSTMENT (port_spin_button_adj), 1, 0);
	gtk_widget_show (port_spin_button);
	gtk_fixed_put (GTK_FIXED (fixed1), port_spin_button, 160, 72);
	gtk_widget_set_size_request (port_spin_button, 69, 25);

	label2 = gtk_label_new (_("Server Port:"));
	gtk_widget_show (label2);
	gtk_fixed_put (GTK_FIXED (fixed1), label2, 40, 72);
	gtk_widget_set_size_request (label2, 106, 22);
	gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_LEFT);

	label3 = gtk_label_new (_("Username:"));
	gtk_widget_show (label3);
	gtk_fixed_put (GTK_FIXED (fixed1), label3, 48, 128);
	gtk_widget_set_size_request (label3, 94, 22);
	gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_LEFT);

	nessusd_username_entry = gtk_entry_new ();
	gtk_widget_show (nessusd_username_entry);
	gtk_fixed_put (GTK_FIXED (fixed1), nessusd_username_entry, 160, 128);
	gtk_widget_set_size_request (nessusd_username_entry, 158, 25);

	page2 = gnome_druid_page_standard_new ();
	gtk_widget_show_all (page2);
	gnome_druid_append_page (GNOME_DRUID (getting_started_druid),
	GNOME_DRUID_PAGE (page2));
	gnome_druid_page_standard_set_title (GNOME_DRUID_PAGE_STANDARD (page2), _("Database Information"));

	druid_vbox2 = GNOME_DRUID_PAGE_STANDARD (page2)->vbox;
	gtk_widget_show (druid_vbox2);
	gtk_container_set_border_width (GTK_CONTAINER (druid_vbox2), 16);

	vbox1 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox1);
	gtk_box_pack_start (GTK_BOX (druid_vbox2), vbox1, TRUE, TRUE, 0);

	label4 = gtk_label_new (_("Sussen requires a database to store information collected from scans.  \nPlease select one of the following options:"));
	gtk_widget_show (label4);
	gtk_box_pack_start (GTK_BOX (vbox1), label4, FALSE, FALSE, 0);
	gtk_label_set_justify (GTK_LABEL (label4), GTK_JUSTIFY_LEFT);

	hbox1 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox1);
	gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

	db_radio_button = gtk_radio_button_new_with_mnemonic (NULL, _("Use existing GNOME-DB datasource:"));
	gtk_widget_show (db_radio_button);
	gtk_box_pack_start (GTK_BOX (hbox1), db_radio_button, FALSE, FALSE, 0);
	gtk_radio_button_set_group (GTK_RADIO_BUTTON (db_radio_button), db_radio_button_group);
	db_radio_button_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (db_radio_button));

	dbdatasourceselector1 = gnome_db_data_source_selector_new (NULL);
	gtk_widget_show (dbdatasourceselector1);
	gtk_box_pack_start (GTK_BOX (hbox1), dbdatasourceselector1, FALSE, FALSE, 6);

	new_dsn_radio = gtk_radio_button_new_with_mnemonic (NULL, _("Create new GNOME-DB datasource"));
	gtk_widget_show (new_dsn_radio);
	gtk_box_pack_start (GTK_BOX (vbox1), new_dsn_radio, FALSE, FALSE, 0);
	gtk_radio_button_set_group (GTK_RADIO_BUTTON (new_dsn_radio), db_radio_button_group);
	db_radio_button_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (new_dsn_radio));

	end_page = gnome_druid_page_edge_new (GNOME_EDGE_FINISH);
	gtk_widget_show (end_page);
	gnome_druid_append_page (GNOME_DRUID (getting_started_druid),
							GNOME_DRUID_PAGE (end_page));
	gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (end_page),
							_("Sussen has the necessary information to proceed.  Click 'Apply' to start using Sussen."));

	dialog_action_area1 = GTK_DIALOG (getting_started_dialog)->action_area;
	gtk_widget_show (dialog_action_area1);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

	/* Store pointers to all widgets, for use by lookup_widget(). */
	GLADE_HOOKUP_OBJECT_NO_REF (getting_started_dialog, getting_started_dialog, "getting_started_dialog");
	GLADE_HOOKUP_OBJECT_NO_REF (getting_started_dialog, dialog_vbox1, "dialog_vbox1");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, getting_started_druid, "getting_started_druid");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, start_page, "start_page");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, page1, "page1");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, druid_vbox1, "druid_vbox1");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, fixed1, "fixed1");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, label1, "label1");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, nessusd_entry, "nessusd_entry");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, port_spin_button, "port_spin_button");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, label2, "label2");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, label3, "label3");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, nessusd_username_entry, "nessusd_username_entry");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, page2, "page2");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, druid_vbox2, "druid_vbox2");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, vbox1, "vbox1");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, label4, "label4");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, hbox1, "hbox1");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, db_radio_button, "db_radio_button");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, dbdatasourceselector1, "dbdatasourceselector1");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, new_dsn_radio, "new_dsn_radio");
	GLADE_HOOKUP_OBJECT (getting_started_dialog, end_page, "end_page");
	GLADE_HOOKUP_OBJECT_NO_REF (getting_started_dialog, dialog_action_area1, "dialog_action_area1");

	return getting_started_dialog;
}

gboolean gs_page2_next (GnomeDruidPage *druidpage, GtkWidget *widget, gpointer user_data) {

	GtkWidget *next_page = NULL;
	GtkWidget *the_druid;
	gint user_druid_choice;
	GSList *list;
	GtkWidget *button;
	
	the_druid = lookup_widget (druid,"getting_started_druid");
	button = lookup_widget (druid, "db_radio_button");
		
	list = gtk_radio_button_get_group (GTK_RADIO_BUTTON(button));
	if (list) {
		while (list) {
			
			GtkWidget *button = list->data;
						
			if(GTK_TOGGLE_BUTTON(button)->active) {
				
				user_druid_choice = (gint)g_object_get_data(G_OBJECT(button), "response");
				
				switch (user_druid_choice) {
				
					case USE_EXISTING_GNOMEDB: {
						
						if (existing_dsn && existing_dsn_user && existing_dsn_pass) {						
							if (strlen(existing_dsn) > 0 && strlen(existing_dsn_user) > 0 && strlen(existing_dsn_pass) > 0) {
								set_backend_xml (existing_dsn, existing_dsn_user, existing_dsn_pass);
								next_page = lookup_widget (druid,"end_page");						
							}
						} else {
							sussen_error_dialog (_("You must select a connection to use"));
							next_page = lookup_widget (druid,"page2");							
						}
						break;
					}

					case CREATE_NEW_GNOMEDB: {
						next_page = lookup_widget (druid,"end_page");
						create_new_connection = TRUE;
						gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (next_page),
														_("Click Apply to continune.  Another druid will launch and guide you through the creation of a new datasource"));
						break;
					}
				}
			}
			list = list->next;
		}
	}
	
	gnome_druid_set_page (GNOME_DRUID(the_druid),GNOME_DRUID_PAGE (next_page));
	return TRUE;
}

gboolean gs_page1_next (GnomeDruidPage *druidpage, GtkWidget *widget, gpointer user_data) {
	
	GtkWidget *w;
	GtkWidget *next_page;
	GtkWidget *the_druid;
	GSList *list = NULL;
	const gchar *hostname;
	const gchar *username;
	gint port;
	
	the_druid = lookup_widget (druid,"getting_started_druid");
	next_page = lookup_widget (druid,"page2");
	
	w = lookup_widget (druid,"nessusd_entry");
	hostname = gtk_entry_get_text (GTK_ENTRY(w));
	
	w = lookup_widget (druid, "port_spin_button");
	port = (gint)gtk_spin_button_get_value (GTK_SPIN_BUTTON(w));
	
	w = lookup_widget (druid,"nessusd_username_entry");
	username = gtk_entry_get_text (GTK_ENTRY(w));

	gchar *tmp = g_strdup_printf ("%s:%d:%s:1",hostname,port,username);
	list = g_slist_append (list, g_strdup(tmp));
	set_server_xml (g_slist_copy(list));
	g_free (tmp);
	
	gnome_druid_set_show_finish (GNOME_DRUID(the_druid), FALSE);
	gnome_druid_set_page (GNOME_DRUID(the_druid),GNOME_DRUID_PAGE (next_page));

	return TRUE;	
}

void finish_getting_started_druid (GnomeDruidPage *druidpage, GtkWidget *widget, gpointer user_data) {

	gtk_widget_destroy (druid);
	gtk_main_quit ();
}

void connection_selector_cb (GtkOptionMenu *optionmenu, gpointer user_data) {
	
	const gchar *user_selection;
	user_selection = gnome_db_option_menu_get_selection (optionmenu);
	
	GdaDataSourceInfo *cur_dsn = gda_config_find_data_source (user_selection);
	existing_dsn = g_strdup (cur_dsn->name);
	existing_dsn_user = g_strdup (cur_dsn->username);
	existing_dsn_pass = g_strdup (cur_dsn->password);
}

gboolean show_getting_started_druid (void) {
	
	GtkWidget *w;
	
	druid = create_sussen_getting_started_druid_dialog ();
	gtk_widget_show (druid);

	w = lookup_widget (druid, "getting_started_druid");
	g_signal_connect_swapped (GTK_OBJECT (w),
							  "cancel",
							  G_CALLBACK (gtk_widget_destroy),
							  (gpointer) druid);	
	
	w = lookup_widget (druid, "page1");
	g_signal_connect (GTK_OBJECT (w),
					  "next",
					  G_CALLBACK (gs_page1_next),
					  NULL);	

	w = lookup_widget (druid, "page2");
	g_signal_connect (GTK_OBJECT (w),
					  "next",
					  G_CALLBACK (gs_page2_next),
					  NULL);	
	
	w = lookup_widget (druid, "end_page");
	g_signal_connect (GTK_OBJECT (w),
					  "finish",
					  G_CALLBACK (finish_getting_started_druid),
					  NULL);

	w = lookup_widget (druid, "dbdatasourceselector1");
	g_signal_connect (GTK_OBJECT (w),
					  "changed",
					  G_CALLBACK (connection_selector_cb),
					  NULL);
					  					  
	w = lookup_widget (druid, "port_spin_button");
	gtk_spin_button_set_value (GTK_SPIN_BUTTON(w),1241);

	w = lookup_widget (druid, "db_radio_button");
	g_object_set_data(G_OBJECT(w), "response", (void*)USE_EXISTING_GNOMEDB);
	
	w = lookup_widget (druid, "new_dsn_radio");
	g_object_set_data(G_OBJECT(w), "response", (void*)CREATE_NEW_GNOMEDB);	
	
	gtk_main ();
	
	if (create_new_connection) {
		return TRUE;
	} 
	
	return FALSE;
}
