/* 
 * Copyright (C) 2003 Star Chamber Inc.
 *
 * Sussen - sussen-network.h
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Author: Loren Bandiera <lorenb@starchamber.ca>
 */
 
#ifndef __SUSSEN_NETWORK_H
#define __SUSSEN_NETWORK_H

#include <glib.h>
#include <gnet.h>

#define NESSUS_PROTO_NAME "< NTP/1.2 >< plugins_cve_id plugins_version plugins_bugtraq_id timestamps dependencies >\n"

/* nessus server messages */

#define MSG_ERROR 1
#define MSG_PORT 2
#define MSG_HOLE 3
#define MSG_BYE 4
#define MSG_INFO 5
#define MSG_STAT 6
#define MSG_PING 7
#define MSG_PLUGINS_ORDER 8
#define MSG_FINISHED 9
#define MSG_STAT2 10
#define MSG_NOTE 11
#define MSG_TIME 12

#define MSG_ERROR_STR "ERROR"
#define MSG_PORT_STR "PORT"
#define MSG_HOLE_STR "HOLE"
#define MSG_INFO_STR "INFO"
#define MSG_NOTE_STR "NOTE"
#define MSG_STAT_STR "STATUS"
#define MSG_BYE_STR "BYE"
#define MSG_PING_STR "PING"
#define MSG_PLUGINS_ORDER_STR "PLUGINS_ORDER"
#define MSG_FINISHED_STR "FINISHED"
#define MSG_TIME_STR "TIME"

#define TIMER_HOST_START		1
#define TIMER_HOST_END			2
#define TIMER_SCAN_START		3
#define TIMER_SCAN_END			4

void sussen_network_connect (const gchar *hostname, gint port, const gchar *login, const gchar *pass);
void sussen_network_disconnect (void);
void sussen_network_attack (const gchar *hostname, const gchar *session_name);
void sussen_network_restore_session (const gchar *session_name);
void update_scan_status (gchar *msg, gint short_status);
gboolean sussen_network_write (GTcpSocket *socket, gchar *str);
gchar* sussen_network_read (GTcpSocket *socket, gint length);

#endif
