/* 
 * Copyright (C) 2003 Star Chamber Inc.
 *
 * Sussen - sussen-util.h
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Author: Loren Bandiera <lorenb@starchamber.ca>
 */
 
#ifndef __SUSSEN_UTIL_H
#define __SUSSEN_UTIL_H

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

#define EX_NONE 1
#define EX_DNS 2
#define EX_IP 4
#define EX_NFS 8

void update_status (gchar *msg);
void set_target_defaults (void);
void set_widgets_sensitive (gboolean state, gboolean during_scan);
GtkWidget* create_sussen_cert_druid_dialog (void);
GtkWidget* lookup_widget (GtkWidget *widget, const gchar *widget_name);
void sussen_error_dialog (const gchar *msg);
void update_connected_status (const gchar *hostname, gboolean state);
void set_server_properties_defaults (GladeXML *xml, GData *prefs);
void get_server_properties (GtkWidget *widget, gpointer user_data);
gchar* sussen_strcompress (const gchar *source);
gchar* target_translate (const gchar *buf);

#endif
